﻿XIncludeFile "OWire_Module_dll.pbi"

Procedure SearchROM(List SN.OW_SN(), Port)
  Protected Count, Sensor.OW_SN
  
  If ListSize(SN())
    ClearList(SN())
  EndIf
  
  Count=0
  OW_SearchROM_Reset()
  While OW_SearchROM_Enum(@Sensor)=#True
    Count+1
    If AddElement(SN())
      CopyMemory(@Sensor, @SN(), SizeOf(OW_SN))
    EndIf
  Wend
  
  ProcedureReturn Count
EndProcedure

Procedure.s SN_Text(*x.OW_SN)
  Protected String.s, i
  
  String = RSet(Hex(*x\Type), 2, "0")+"-"
  
  For i=5 To 0 Step -1
    String + RSet(Hex(*x\Number[i]), 2, "0")
  Next i
  
  String + "-"+RSet(Hex(*x\CRC), 2, "0")
  
  ProcedureReturn String
EndProcedure

Procedure ReadPowerSupply(Port)
  OW_WriteByte($B4, Port)
  SP_WriteByte($FF, Port)
  Delay(10)
  ProcedureReturn SP_ReadByte(Port) & 1
EndProcedure

NewList ID.OW_SN()
OpenConsole("Тип подключения '1-Wire' устройств")

Print("Использовать порт COM")
PortNum=Val(Input())

If OW_OpenPort("COM"+PortNum, 0)
  
  PrintN("Найдено "+SearchROM(ID(), 0)+" '1-Wire' устройств")
  PrintN("")
  ForEach ID()
    OW_SelectROM(@ID(), 0)
    ;x=OW_ReadPowerSupply(0)
    x=ReadPowerSupply(0)
    PrintN(SN_Text(@ID())+"  "+Str(2+x)+" вывода  "+
           Left("(Паразитное питание)", 20*(x!1)))
  Next
  
  OW_ClosePort(0)
Else
  PrintN("Не удалось открыть порт COM"+PortNum)
EndIf

PrintN("")
PrintN("Для закрытия программы, нажмите Enter")
Input()
; IDE Options = PureBasic 5.22 LTS (Windows - x86)
; CursorPosition = 38
; FirstLine = 19
; Folding = -
; EnableUnicode
; EnableXP
; UseIcon = Res\.ico
; Executable = ..\  .exe